<div>
  <div id="subheader">
    <div style="float: left; margin-top: 13px;">
      <h5 style="margin-top: 0px; margin-left: 20px">Edit Trip No: {{ trip.refNumber }}</h5>
    </div>
    <div class="item" style="margin-top: 10px;">
      <div *ngIf='!ds.isSales()'>
        <div style='display: inline-block' *ngIf='ds.isAdmin() && trip.statusId == 6'>
          Allow Edit: <dx-switch [(value)]="trip.allowEdit" (onValueChanged)='onIsLockSwtich($event)'></dx-switch>
        </div>
        <dx-button class="tripEditBtn" [visible]="trip.statusId < 6" type="default" text="Scheduler"
          (onClick)="schedulerTrip()"></dx-button>
        <dx-button class="tripEditBtn" [visible]="trip.statusId === 5 && trip.sendFinish" type="danger" text="Finish"
          (onClick)="channgeTripStatus(6)"></dx-button>
        <dx-button class="tripEditBtn" [visible]="!ds.isTrans() && trip.statusId === 2" type="normal" icon="runner"
          text="Send to SAP" (onClick)="channgeTripStatus(3)"></dx-button>
        <dx-button class="tripEditBtn" [visible]="!ds.isTrans() && trip.statusId === 1" type="normal" text="Approve"
          (onClick)="channgeTripStatus(2)"></dx-button>
        <dx-button class="tripEditBtn" [visible]="!ds.isTrans() && trip.statusId === 1" type="danger" text="Reject"
          (onClick)="channgeTripStatus(0)"></dx-button>
        <dx-button class="tripEditBtn" [visible]="trip.statusId < 2" type="success" icon="check" text="Save"
          (onClick)="onSaveTrip(trip)"></dx-button>
        <dx-button class="tripEditBtn" type="normal" icon="remove" text="Close" (onClick)="goBack()"></dx-button>
      </div>
    </div>
  </div>
  <br />
  <dx-tab-panel [height]='ds.gridHeight' (onTitleClick)='onPanelTitleClick($event)'>
    <dxi-item itemTemplate="tabInformation" title="Information">
      <div *dxTemplate="let tab of 'tabInformation'">
        <dx-form [colCount]="3" [formData]='trip' [showValidationSummary]="false"
          style="padding:20px;border-bottom:1px solid grey" [disabled]="trip.statusId >= 4 || tripHeaderState == 2">
          <dxi-item itemType="group" [colSpan]="1" [colCount]='1'>
            <dxi-item [label]="{text: 'Loading Date'}" dataField="plannedDate" editorType="dxDateBox"
              [editorOptions]="{ displayFormat: 'dd.MM.yyyy HH:mm', type: 'datetime', width:'100%', readOnly: tripHeaderState == 2, max: trip.maxplannedDate, min: trip.minplannedDate }">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
            <dxi-item [label]="{text: 'Depot'}" dataField="depotId" editorType="dxSelectBox"
              [editorOptions]="{ dataSource: dsDepot, valueExpr: 'id', displayExpr: 'name', readOnly: tripHeaderState == 1 }">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
            <dxi-item [label]="{text: 'Transporter'}" dataField="transporterId" editorType="dxSelectBox"
              [editorOptions]="{ dataSource: dsTransporter, valueExpr: 'id', displayExpr: 'name', readOnly: tripHeaderState == 1 }">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
          </dxi-item>
          <dxi-item itemType="group" [colSpan]="1" [colCount]='1'>
            <dxi-item [label]="{text: 'Truck'}" dataField="carId" editorType="dxSelectBox"
              [editorOptions]="{ dataSource: dsCar, valueExpr: 'id', displayExpr: 'registrationNo', readOnly: tripHeaderState == 1 }">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
            <dxi-item [label]="{text: 'Trailer'}" dataField="tankId" editorType="dxSelectBox"
              [editorOptions]="{ dataSource: dsTank, valueExpr: 'id', displayExpr: 'registrationNo', onValueChanged: onTankChanged, readOnly: tripHeaderState == 1 }">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
            <dxi-item [label]="{text: 'Driver'}" dataField="driverId" editorType="dxLookup"
              [editorOptions]="{ dataSource: dsDriver, valueExpr: 'id', displayExpr: displayDriver, closeOnOutsideClick:true, searchExpr: ['firstName', 'lastName'], disabled: tripHeaderState == 1 }">
              <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
          </dxi-item>
          <dxi-item itemType="group" [colSpan]="1" [colCount]='1'>
            <dxi-item [label]="{text: 'Trip no'}" dataField="orderIndex" editorType="dxNumberBox"
              [editorOptions]="{ showSpinButtons: true, min: 1, max: 10, readOnly: tripHeaderState == 1 }">
              <!-- <dxi-validation-rule type="required"></dxi-validation-rule> -->
            </dxi-item>
            <dxi-item [label]="{text: 'Capacity (liters)'}" dataField="capacity" disabled="true" editorType="dxTextBox"
              [editorOptions]="{ textreadOnly: true }"></dxi-item>
            <dxi-item [label]="{text: 'Type'}" dataField="typeId" editorType="dxSelectBox"
              [editorOptions]="{ dataSource: dsMeterType, valueExpr: 'id', displayExpr: 'name', readOnly: true }">
            </dxi-item>
          </dxi-item>
        </dx-form>
        <dx-form [colCount]="3" [formData]='trip' [showValidationSummary]="false" style="padding:20px">
          <dxi-item itemType="group" [colSpan]="3" [colCount]='3'>
            <dxi-item [label]="{text: 'Start'}" dataField="startDate" editorType="dxDateBox"
              [editorOptions]="{ displayFormat: 'dd.MM.yyyy HH:mm', type: 'datetime', width:'100%', readOnly: true }">
            </dxi-item>
            <dxi-item [label]="{text: 'Estimated End'}" dataField="estimatedDate" editorType="dxDateBox"
              [editorOptions]="{ displayFormat: 'dd.MM.yyyy HH:mm', type: 'datetime', width:'100%', readOnly: true }">
            </dxi-item>
            <dxi-item [label]="{text: 'Estimated Km'}" dataField="estimatedKm" editorType="dxNumberBox"
              [editorOptions]="{ readOnly: true }"></dxi-item>
          </dxi-item>
          <dxi-item itemType="group" [colSpan]="3" [colCount]='3'>
            <dxi-item itemType="empty"></dxi-item>
            <dxi-item [label]="{text: 'Estimated Loaded'}" dataField="estimatedLoad" editorType="dxDateBox"
              [editorOptions]="{ displayFormat: 'HH:mm', type: 'time', width:'100%', readOnly: true }"></dxi-item>
            <dxi-item [label]="{text: 'Last Km'}" dataField="lastKm" editorType="dxNumberBox"
              [editorOptions]="{ readOnly: true }"></dxi-item>
          </dxi-item>
        </dx-form>
        <dx-data-grid class="gridContainer" #gridOrder [height]='ds.gridHeight() - 260' width="auto"
          [columnAutoWidth]='true' [allowColumnResizing]='true' [allowColumnReordering]='true'
          [rowAlternationEnabled]='false' [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
          [dataSource]='dsOrders' (onContentReady)="onContentGridOrder($event)"
          (onCellPrepared)='onCellPrepared($event)' (onRowPrepared)='onRowPrepared($event)'
          [editing]="{mode: 'cell', allowUpdating: true }" (onToolbarPreparing)='toolbarPreparing($event)'
          [customizeColumns]='customizeColumns' (onEditingStart)="onCellEditingStart($event)"
          (onRowUpdating)="onRowUpdating($event)">

          <dxo-sorting mode='none'></dxo-sorting>
          <dxo-export [enabled]='true' fileName='orders'></dxo-export>
          <dxo-search-panel [visible]='true'></dxo-search-panel>
          <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
          <dxo-state-storing [enabled]='true' storageKey='gridTripOrdersWST'></dxo-state-storing>

          <dxi-column cellTemplate='position' fixedPosition='left' [fixed]='true' [allowResizing]='false' width='50'
            [showInColumnChooser]='false' [visible]='!ds.isSales()'>
            <div *dxTemplate="let row of 'position'" style="text-align:center;">
              <div class="dx-icon dx-icon-arrowup" (click)="changeOrder(row.data, true)"
                *ngIf='row.rowIndex > 0 && !ds.isSales()'>
              </div>
              <div class="dx-icon dx-icon-arrowdown" (click)="changeOrder(row.data, false)"
                *ngIf='row.rowIndex < row.component.totalCount() - 1 && !ds.isSales()'>
              </div>
            </div>
          </dxi-column>
          <dxi-column caption='SO Number' dataField='ol_refNumber' dataType='number' [allowHeaderFiltering]='false'
            [allowEditing]="false"></dxi-column>
          <dxi-column caption='Customer Code' dataField='c_code' dataType='string' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Customer' dataField='c_name' dataType='string' [allowHeaderFiltering]='false'
            [allowEditing]="false"></dxi-column>
          <dxi-column caption='Ship to Party' dataField='ca_code' dataType='string' [allowEditing]="false"></dxi-column>
          <dxi-column caption='County' dataField='ca_region' dataType='string' [allowEditing]="false"></dxi-column>
          <dxi-column caption='City' dataField='ca_city' dataType='string' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Status' dataField='ol_statusId' [allowEditing]='false'>
            <dxo-lookup [dataSource]='dsStatus' valueExpr='id' displayExpr='name'></dxo-lookup>
          </dxi-column>
          <dxi-column caption='Scheduled Date' dataField='ol_scheduledDate' dataType='datetime'
            [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Estimated Unloaded' dataField='ol_estimatedUnload' dataType='string'
            [allowEditing]="false"></dxi-column>
          <!-- <dxi-column caption='Depot' dataField='d_name' dataType='string'></dxi-column> -->
          <dxi-column caption='Product' dataField='p_name' dataType='string' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Product code' dataField='p_code' dataType='string' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Ordered Quantity L15' dataField='ol_quantity' dataType='number' minWidth='220'
            [allowHeaderFiltering]='false' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Loaded Quantity L15' dataField='ol_loadedQuantity' dataType='number'
            [allowHeaderFiltering]='false' [allowEditing]="!ds.isSales()"></dxi-column>
          <dxi-column caption='Delivered Quantity L15' dataField='ol_deliveredQuantity' dataType='number'
            [allowHeaderFiltering]='false' [allowEditing]="!ds.isSales()"></dxi-column>
          <dxi-column caption='Delivery Date' dataField='ol_deliveryDate' dataType='datetime'
            [calculateDisplayValue]='ds.getDateTime' [allowEditing]="false"></dxi-column>
          <dxi-column caption='Estimated Km' dataField='ol_estimatedKm' dataType='number' [allowHeaderFiltering]='false'
            [allowEditing]="false"></dxi-column>
          <dxi-column caption='Address' dataField='ca_description' dataType='string' [allowHeaderFiltering]='false'
            [allowEditing]="false"></dxi-column>
          <dxi-column caption='Comments' dataField='comments' dataType='string' [allowHeaderFiltering]='false'
            [allowEditing]="false"></dxi-column>
          <dxi-column cellTemplate='actions' name='Actions' width='85' fixedPosition='right' [allowResizing]='false'
            [fixed]='true' [showInColumnChooser]='false' [visible]='!ds.isSales()'>
            <div *dxTemplate="let row of 'actions'" id="actionsColumn">
              <dx-button class="dx-success" icon="upload" hint="Transfer fuel" (onClick)="addGasStationOrder(row.data)"
                [visible]='isTransferVisibleEv(row.data)'></dx-button>
              <dx-button class="dx-success" icon="doc" hint="Upload ticket" (onClick)="uploadTicket(row.data.ol_id)"
                [visible]='isUploadVisible(row.data)'></dx-button>
              <dx-button class="dx-success" icon="repeat" hint="Send to approve" (onClick)="sendToApproved(row.data, 1)"
                [visible]='isApproveVisible(row.data)'></dx-button>
              <dx-button class="dx-success" icon="trash" hint="Delete order" (onClick)="deleteOrder(row.data)"
                [visible]='!ds.isSales() && (trip.statusId == 0 || trip.statusId == 1)'></dx-button>
            </div>
          </dxi-column>
          <dxo-summary [calculateCustomSummary]="calculateSummary">
            <dxi-total-item column="ol_refNumber" summaryType="count" name='orderCount'></dxi-total-item>
            <dxi-total-item column="ol_quantity" summaryType="sum" [customizeText]="customLoadedQuant"></dxi-total-item>
            <dxi-total-item column="ol_quantity" summaryType="custom" name="availableQuantSummary"
              [customizeText]="customAvailableQuant"></dxi-total-item>
          </dxo-summary>
        </dx-data-grid>
      </div>
    </dxi-item>
    <dxi-item itemTemplate="tabMap" title="Map">
      <div *dxTemplate="let tab of 'tabMap'">
        <dx-map (onInitialized)="routeInitialize($event)" [zoom]="10" [height]="700" width="100%"
          key='AIzaSyCTv0_YYulL-OuLEm2t0yf_MBg19Fxn9zk'></dx-map>
      </div>
    </dxi-item>
    <dxi-item itemTemplate="tabHistory" title="History">
      <div *dxTemplate="let tab of 'tabHistory'" style="padding:15px">
        <dx-data-grid class="gridContainer" #gridHistory [height]='ds.gridHeight() - 310' [columnAutoWidth]='true'
          [allowColumnResizing]='true' [allowColumnReordering]='true' [rowAlternationEnabled]='ds.rowAlternationEnabled'
          [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines' [dataSource]='dsOrderHistory'
          [customizeColumns]='customizeColumns' (onToolbarPreparing)='onToolbarHistory($event)'>

          <dxo-sorting mode='none'></dxo-sorting>
          <dxo-export [enabled]='true' fileName='order_history'></dxo-export>
          <dxo-search-panel [visible]='true'></dxo-search-panel>
          <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
          <dxo-column-fixing [enabled]="true"></dxo-column-fixing>

          <dxi-column caption='SO Number' dataField='ol_refNumber' dataType='number' width='80'></dxi-column>
          <dxi-column caption='Customer' dataField='c_name' dataType='string'></dxi-column>
          <dxi-column caption='Delivery Date' dataField='ol_deliveryDate' dataType='datetime'
            [calculateDisplayValue]='ds.getDateTime'></dxi-column>
          <dxi-column caption='Delivery Quantity L15' dataField='ol_deliveredQuantity' dataType='number'></dxi-column>
          <dxi-column cellTemplate="files" fixedPosition='right' [allowResizing]='false' [fixed]='true'
            [showInColumnChooser]='false' width="50px">
            <div *dxTemplate="let file of 'files'">
              <a *ngIf='file.data.hasTicket' href="{{imagePath + file.data.ol_id + '_img.png?lastModify=' + currentDate }}" target="_blank">
                <i class="dx-icon dx-icon-photo"></i>
              </a>
            </div>
          </dxi-column>
        </dx-data-grid>
        <div *ngIf="trip.typeId == 1 && (trip.hasTicket || trip.manuallyLoadedQuantity)" style="padding: 10px">
          <hr>
          <h3>Dipstick Loaded</h3>
          <div>
            <p style="display:inline-block; width: 200px;">Date: {{trip.manuallyLoadedDate | date: 'dd.MM.yyyy HH:mm'}}
            </p>
            <p style="display:inline-block; width: 200px;">Quantity: {{trip.manuallyLoadedQuantity }}</p>
            <p style="display:inline-block; width: 200px;">Ticket:
              <a href="{{imagePath + trip.refNumber + '_img.png'}}" target="_blank">
                <i class="dx-icon dx-icon-photo"></i>
              </a>
            </p>
          </div>
        </div>
      </div>
    </dxi-item>
  </dx-tab-panel>
</div>

<app-gas-station [gasVisible]='isGasStationVisible' [gs]='gs' [gsTank]='gsTank' (save)="saveGS($event)"
  (cancel)="cancelGS()" (popupHidden)="cancelGS()">
</app-gas-station>

<dx-popup title='Add Order' [(visible)]='isAddOrderVisible' width='auto' height='auto' [position]="ds.popupPosition">
  <div *dxTemplate="let data of 'title'">
    <div class="logo-small" style="float:left">
      <img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
    </div>
    <!-- <dx-button #enableButton text="Add Orders" icon="plus" (onClick)="addOrdersToTrip()" [disabled]='true'></dx-button> -->
    <div style="margin-left: 5px; float: right">
      <dx-button icon="remove" (onClick)='cancelClick()'></dx-button>
    </div>
  </div>
  <div *dxTemplate="let data of 'content'">
    <dx-data-grid #gridAddOrder [dataSource]="dsAddOrders" style="margin-top:10px"
      (onSelectionChanged)="selectionChangedHandler($event)" [height]='440' [allowColumnResizing]='true'
      [allowColumnReordering]='true' [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
      (onToolbarPreparing)="onOrderToolbarPreparing($event)" (onInitialized)="initAddOrdersGrid($event)">

      <dxo-selection mode="multiple" showCheckBoxesMode="always"></dxo-selection>
      <dxo-header-filter [visible]='true'></dxo-header-filter>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>

      <dxi-column caption='SO Number' dataField='ol_refNumber' dataType='number' [allowHeaderFiltering]='false'>
      </dxi-column>
      <dxi-column caption='Customer Code' dataField='c_code' dataType='string'></dxi-column>
      <dxi-column caption='Customer' dataField='c_name' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
      <dxi-column caption='Ship to Party' dataField='ca_code' dataType='string'></dxi-column>
      <dxi-column caption='County' dataField='ca_region' dataType='string'></dxi-column>
      <dxi-column caption='City' dataField='ca_city' dataType='string'></dxi-column>
      <!-- <dxi-column caption='Depot' dataField='d_name' dataType='string'></dxi-column> -->
      <dxi-column caption='Range' dataField='r_value' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
      <dxi-column caption='Requested Date' dataField='ol_requestDate' dataType='date'
        calculateSortValue='ol_requestDate' [calculateDisplayValue]='ds.getDate'></dxi-column>
      <dxi-column caption='Product' dataField='p_name' dataType='string'></dxi-column>
      <dxi-column caption='Product code' dataField='p_code' dataType='string'></dxi-column>
      <dxi-column caption='Quantity' dataField='ol_quantity' dataType='number' [allowHeaderFiltering]='false'>
      </dxi-column>
      <dxi-column caption='Truck' dataField='car_registrationNo' dataType='string' [allowEditing]="false"></dxi-column>
      <dxi-column caption='Trailer' dataField='tank_registrationNo' dataType='string' [allowEditing]="false">
      </dxi-column>
      <dxi-column caption='Address' dataField='ca_description' dataType='string' [allowHeaderFiltering]='false'>
      </dxi-column>
      <div *dxTemplate="let data of 'selectedQuantity'">
        <label>Quantity selected/remains: {{selected.quantity}} /
          <span [class.redTxt]="selected.quantity > selected.remains">{{selected.remains}}</span>
        </label>
      </div>
    </dx-data-grid>
  </div>
</dx-popup>

<dx-popup [(visible)]="isDipstickPopupVisible" width='auto' height='auto' [position]="ds.popupPosition">
  <div *dxTemplate="let data of 'title'">
    <div class="logo-small" style="float:left">
      <img src="assets/img/Logo1.png" style="width:25px; height:25px; display:block;" />
    </div>
    <h4 style="text-align: left;">Dipstick quantity</h4>
    <!-- <dx-button #enableButton text="Add Orders" icon="plus" (onClick)="addOrdersToTrip()" [disabled]='true'></dx-button> -->
    <div style="margin-left: 5px; float: right">
      <dx-button icon="remove" (onClick)='cancelClick()'></dx-button>
    </div>
  </div>
  <div *dxTemplate="let data of 'content'">
    <label>Loaded quantity [L15]</label>
    <dx-number-box [(value)]="dipstickLoaded" style="margin: 10px 30px;" [class.redError]="dipstickLoaded <= 0">
    </dx-number-box>
    <dx-button text="Upload file & quant" (onClick)="uploadDipstickTicket(dipstickLoaded, trip.refNumber)"
      style="float: right;margin: 0px 10px 15px"></dx-button>
    <dx-button text='Update quant' type='success' [visible]='ds.isAdmin()'
      (onClick)='onUpdateQuantity(dipstickLoaded, trip.id)' style='float:right;margin: 0px 10px 15px'></dx-button>
  </div>
</dx-popup>